/*
 * Copyright (c) 2002 Juli Mallett.  All rights reserved.
 *
 * This software was written by Juli Mallett <jmallett@FreeBSD.org> for the
 * FreeBSD project.  Redistribution and use in source and binary forms, with
 * or without modification, are permitted provided that the following
 * conditions are met:
 *
 * 1. Redistribution of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistribution in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/cdefs.h>

#include <sys/param.h>
#include <sys/mount.h>
#include <sys/disklabel.h>
#include <sys/stat.h>

#include <ufsmount.h>
#include <dinode.h>
#include <fs.h>

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <libufs.h>


void ufs1inoswapen(struct ufs1_dinode *d)
{
	int i;
	d->di_mode       = (uint16_t)bswap_16(d->di_mode);
	d->di_nlink      = (int16_t)bswap_16(d->di_nlink);
	d->di_ogid       = (uint16_t)bswap_16(d->di_ogid);
	d->di_ouid       = (uint16_t)bswap_16(d->di_ouid);
	d->di_size       = (uint64_t)bswap_64(d->di_size);
	d->di_atime      = (int32_t)bswap_32(d->di_atime);
	d->di_atimensec  = (int32_t)bswap_32(d->di_atimensec);
	d->di_mtime      = (int32_t)bswap_32(d->di_mtime);
	d->di_mtimensec  = (int32_t)bswap_32(d->di_mtimensec);
	d->di_ctime      = (int32_t)bswap_32(d->di_ctime);
	d->di_ctimensec  = (int32_t)bswap_32(d->di_ctimensec);
	for (i = 0; i < NDADDR; i++)
	  d->di_db[i]    = (ufs1_daddr_t)bswap_32(d->di_db[i]);
	for (i = 0; i < NIADDR; i++)
	  d->di_ib[i]    = (ufs1_daddr_t)bswap_32(d->di_ib[i]);
	d->di_flags      = (uint32_t)bswap_32(d->di_flags);
	d->di_blocks     = (int32_t)bswap_32(d->di_blocks);
	d->di_gen        = (int32_t)bswap_32(d->di_gen);
	d->di_uid        = (uint32_t)bswap_32(d->di_uid);
	d->di_gid        = (uint32_t)bswap_32(d->di_gid);
	for (i = 0; i < 2; i++)
	  d->di_spare[i] = (int32_t)bswap_32(d->di_spare[i]);
}

void ufs2inoswapen(struct ufs2_dinode *d)
{
	int i;
	d->di_mode       = (uint16_t)bswap_16(d->di_mode);
	d->di_nlink      = (int16_t)bswap_16(d->di_nlink);
	d->di_uid        = (uint32_t)bswap_32(d->di_uid);
	d->di_gid        = (uint32_t)bswap_32(d->di_gid);
	d->di_blksize    = (uint32_t)bswap_32(d->di_blksize);
	d->di_size       = (uint64_t)bswap_64(d->di_size);
	d->di_blocks     = (uint64_t)bswap_64(d->di_blocks);
	d->di_atime      = (ufs_time_t)bswap_64(d->di_atime);
	d->di_mtime      = (ufs_time_t)bswap_64(d->di_mtime);
	d->di_ctime      = (ufs_time_t)bswap_64(d->di_ctime);
	d->di_birthtime  = (ufs_time_t)bswap_64(d->di_birthtime);
	d->di_mtimensec  = (int32_t)bswap_32(d->di_mtimensec);
	d->di_atimensec  = (int32_t)bswap_32(d->di_atimensec);
	d->di_ctimensec  = (int32_t)bswap_32(d->di_ctimensec);
	d->di_birthnsec  = (int32_t)bswap_32(d->di_birthnsec);
	d->di_gen        = (int32_t)bswap_32(d->di_gen);
	d->di_kernflags  = (uint32_t)bswap_32(d->di_kernflags);
	d->di_flags      = (uint32_t)bswap_32(d->di_flags);
	d->di_extsize    = (int32_t)bswap_32(d->di_extsize);
	for (i = 0; i < NXADDR; i++)
	  d->di_extb[i]  = (ufs2_daddr_t)bswap_64(d->di_extb[i]);
	for (i = 0; i < NDADDR; i++)
	  d->di_db[i]    = (ufs2_daddr_t)bswap_64(d->di_db[i]);
	for (i = 0; i < NIADDR; i++)
	  d->di_ib[i]    = (ufs2_daddr_t)bswap_64(d->di_ib[i]);
	for (i = 0; i < 3; i++)
	  d->di_spare[i] = (int64_t)bswap_64(d->di_spare[i]);
}

int
getino(struct uufsd *disk, void **dino, ino_t inode, int *mode)
{
	int i;
	ino_t min, max;
	caddr_t inoblock;
	struct ufs1_dinode *dp1;
	struct ufs2_dinode *dp2;
	struct fs *fs;

	ERROR(disk, NULL);

	fs = &disk->d_fs;
	inoblock = disk->d_inoblock;
	min = disk->d_inomin;
	max = disk->d_inomax;
	
	if (inoblock == NULL) {
		inoblock = malloc(fs->fs_bsize);
		if (inoblock == NULL) {
			ERROR(disk, "unable to allocate inode block");
			return (-1);
		}
		disk->d_inoblock = inoblock;
	}
	
	if (inode >= min && inode < max) {
		goto gotit;
	}
	
	bread(disk, fsbtodb(fs, ino_to_fsba(fs, inode)), inoblock, fs->fs_bsize);
	disk->d_inomin = min = inode - (inode % INOPB(fs));
	disk->d_inomax = max = min + INOPB(fs);

	if (disk->d_is_BE) {
	  switch (disk->d_ufs) {
		  case 1:
		    for (i = 0; i < INOPB(fs); i++) {
					dp1 = &((struct ufs1_dinode *)inoblock)[i];
					ufs1inoswapen(dp1);
				}
		    break;
		  case 2:
		    for (i = 0; i < INOPB(fs); i++) {
					dp2 = &((struct ufs2_dinode *)inoblock)[i];
					ufs2inoswapen(dp2);
				}
		    break;
		  default:
		    break;
	  }
	}
	
gotit:	switch (disk->d_ufs) {
	case 1:
		dp1 = &((struct ufs1_dinode *)inoblock)[inode - min];
		if (mode) {
			*mode = dp1->di_mode & IFMT;
		}
		*dino = dp1;
		return (0);
	case 2:
		dp2 = &((struct ufs2_dinode *)inoblock)[inode - min];
		if (mode) {
			*mode = dp2->di_mode & IFMT;
		}
		*dino = dp2;
		return (0);
	default:
		break;
	}
	ERROR(disk, "unknown UFS filesystem type");
	return (-1);
}
